// Win32Configurator.hh
//
// Copyright (C) 2002 Raymond Penners <raymond@dotsphinx.com>
// All rights reserved.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2, or (at your option)
// any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// $Id: Win32Configurator.hh,v 1.1 2003/07/10 06:02:02 temas Exp $
//

#ifndef WIN32CONFIGURATOR_HH
#define WIN32CONFIGURATOR_HH

#include <string>
#include <list>
#include <map>

#include <windows.h>
#include "Configurator.hh"

#include <glibmm/ustring.h>

namespace Gabber {

class Win32Configurator :
  public Configurator
{
public:
  Win32Configurator();
  virtual ~Win32Configurator();

  virtual bool load(const Glib::ustring& filename);
  virtual bool save(const Glib::ustring& filename);
  virtual bool save();
  virtual bool get_value(const Glib::ustring& key, Glib::ustring& out) const;
  virtual bool get_value(const Glib::ustring& key, bool& out) const;
  virtual bool get_value(const Glib::ustring& key, int& out) const;
  virtual bool get_value(const Glib::ustring& key, long& out) const;
  virtual bool get_value(const Glib::ustring& key, double& out) const;
  virtual bool set_value(const Glib::ustring& key, Glib::ustring v);
  virtual bool set_value(const Glib::ustring& key, int v);
  virtual bool set_value(const Glib::ustring& key, long v);
  virtual bool set_value(const Glib::ustring& key, bool v);
  virtual bool set_value(const Glib::ustring& key, double v);
  virtual list<Glib::ustring> get_all_dirs(const Glib::ustring& key) const;
  virtual bool exists_dir(const Glib::ustring& key) const;

private:
  Glib::ustring key_win32ify(const Glib::ustring& key) const;
  Glib::ustring key_add_part(const Glib::ustring& s, const Glib::ustring& t) const;
  void key_split(const Glib::ustring& key, Glib::ustring &parent, Glib::ustring &child) const;
  
  Glib::ustring key_root;
  PHKEY key_root_handle;
};

};

#endif // WIN32CONFIGURATOR_HH
